/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2020 MediaTek Inc.
 */

#ifndef __APUSYS_SECURE_H__
#define __APUSYS_SECURE_H__

#include <linux/arm-smccc.h>
#include <linux/soc/mediatek/mtk_sip_svc.h>

enum mtk_apusys_kernel_op {
	MTK_APUSYS_KERNEL_OP_REVISER_SET_BOUNDARY = 0,			/*  0 */
	MTK_APUSYS_KERNEL_OP_SET_AO_DBG_SEL,				/*  1 */
	MTK_APUSYS_KERNEL_OP_REVISER_CHK_VALUE,				/*  2 */
	MTK_APUSYS_KERNEL_OP_REVISER_SET_DEFAULT_IOVA,			/*  3 */
	MTK_APUSYS_KERNEL_OP_REVISER_GET_INTERRUPT_STATUS,		/*  4 */
	MTK_APUSYS_KERNEL_OP_REVISER_SET_CONTEXT_ID,			/*  5 */
	MTK_APUSYS_KERNEL_OP_REVISER_SET_REMAP_TABLE,			/*  6 */
	MTK_APUSYS_KERNEL_OP_DEVAPC_INIT_RCX,				/*  7 */

	MTK_APUSYS_KERNEL_OP_APUSYS_RV_SETUP_REVISER,			/*  8 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_RESET_MP,			/*  9 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_SETUP_BOOT,			/* 10 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_START_MP,			/* 11 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_STOP_MP,				/* 12 */

	MTK_APUSYS_KERNEL_OP_APUSYS_RV_DISABLE_WDT_ISR,			/* 13 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_CLEAR_WDT_ISR,			/* 14 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_CG_GATING,			/* 15 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_CG_UNGATING,			/* 16 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_COREDUMP_SHADOW_COPY,		/* 17 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_TCMDUMP,				/* 18 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_RAMDUMP,				/* 19 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_TBUFDUMP,			/* 20 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_CACHEDUMP,			/* 21 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_DBG_APB_ATTACH,			/* 22 */
	MTK_APUSYS_KERNEL_OP_APUSYS_RV_REGDUMP,				/* 23 */
	MTK_APUSYS_KERNEL_OP_APUSYS_PWR_DUMP,				/* 24 */
	MTK_APUSYS_KERNEL_OP_APUSYS_REGDUMP,				/* 25 */
	MTK_APUSYS_KERNEL_OP_APUSYS_PWR_RCX,				/* 26 */
	MTK_APUSYS_KERNEL_OP_APUSYS_SETUP_SECURE_MEM,			/* 27 */

	MTK_APUSYS_KERNEL_OP_APUSYS_RV_LOAD_IMAGE,		/* 28 */
	MTK_APUSYS_KERNEL_OP_APUSYS_XPU2APUSYS_D4_SLV,			/* 29 */

	MTK_APUSYS_KERNEL_OP_NUM
};


#endif
