/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2020 MediaTek Inc.
 */


#ifndef __APUSYS_REVISER_SECURE_H__
#define __APUSYS_REVISER_SECURE_H__

#include <linux/arm-smccc.h>
#include <linux/soc/mediatek/mtk_sip_svc.h>

#define APUSYS_SECURE 1
#define BOUNDARY_ALL_NO_CHANGE (0xFFFFFFFF)
#define BOUNDARY_BIT_MASK (0x0F)

#if APUSYS_SECURE
#define APUSYS_ATTR_USE __always_unused
#else
#define APUSYS_ATTR_USE
#endif

enum MTK_APUSYS_KERNEL_OP {
	MTK_APUSYS_KERNEL_OP_REVISER_SET_BOUNDARY = 0,
	MTK_APUSYS_KERNEL_OP_SET_AO_DBG_SEL,
	MTK_APUSYS_KERNEL_OP_REVISER_CHK_VALUE,
	MTK_APUSYS_KERNEL_OP_REVISER_SET_DEFAULT_IOVA,
	MTK_APUSYS_KERNEL_OP_REVISER_GET_INTERRUPT_STATUS,
	MTK_APUSYS_KERNEL_OP_REVISER_SET_CONTEXT_ID,
	MTK_APUSYS_KERNEL_OP_REVISER_SET_REMAP_TABLE,
	MTK_APUSYS_KERNEL_OP_DEVAPC_INIT_RCX,
	MTK_APUSYS_KERNEL_OP_NUM
};


#endif
